<template>
  <div id="card-1">
    <el-row>
      <el-col
        :span="24"
        class="main animate__animated animate__backInRight"
        v-loading="loadings"
        element-loading-text="拼命加载中"
        element-loading-spinner="el-icon-loading"
      >
        <span v-show="view === 'list'">
          <el-col :span="24" class="one"> <span>售后管理</span> </el-col>
          <el-col :span="24" class="two">
            <search-1 :form="searchForm" :statusList="statusList" :typeList="typeList" @onSubmit="search" @toReset="toClose"> </search-1>
          </el-col>
          <el-col :span="24" class="four">
            <data-table :fields="fields" :opera="opera" @query="search" :data="list" :total="total" @exam="toExam"> </data-table>
          </el-col>
        </span>
        <detail v-if="view === 'order'" :id="id" @toBack="toBack"></detail>
      </el-col>
    </el-row>
  </div>
</template>

<script>
const _ = require('lodash');
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions } = createNamespacedHelpers('afterSale');
const { mapActions: dictData } = createNamespacedHelpers('dictData');
export default {
  name: 'card-1',
  props: {},
  components: {
    search1: () => import('@/components/salesParts/parts/search-1.vue'),
    detail: () => import('@/components/salesParts/detail.vue'),
  },
  data: function () {
    const that = this;
    return {
      loadings: true,
      view: 'list',
      searchForm: {},
      list: [],
      total: 0,
      opera: [{ label: '审核', method: 'exam' }],
      fields: [
        { label: '顾客', model: 'customer.name', showTip: false },
        { label: '订单号', model: 'order_detail.no', showTip: false },
        { label: '商品名称', model: 'goods.goods.name', showTip: false },
        {
          label: '售后类型',
          model: 'type',
          format: (i) => {
            let data = that.typeList.find((f) => f.value == i);
            if (data) return data.label;
            else return '暂无';
          },
        },
        {
          label: '售后状态',
          model: 'status',
          format: (i) => {
            let data = that.statusList.find((f) => f.value == i);
            if (data) return data.label;
            else return '暂无';
          },
        },
        { label: '退款金额', model: 'money' },
        { label: '售后处理人', model: 'deal_person.name' },
        { label: '申请时间', model: 'apply_time' },
        { label: '结束时间', model: 'end_time' },
      ],
      typeList: [],
      statusList: [],
      id: '',
    };
  },
  async created() {
    await this.search();
    await this.searchOther();
  },
  methods: {
    ...dictData({ dictQuery: 'query' }),
    ...mapActions(['query', 'fetch', 'create', 'update', 'delete']),
    // 查询
    async search({ skip = 0, limit = this.$limit, ...info } = {}) {
      info.shop = this.user.shop.id;
      let condition = _.cloneDeep(this.searchForm);
      let res = await this.query({ skip, limit, ...condition, ...info });
      if (this.$checkRes(res)) {
        this.$set(this, 'list', res.data);
        this.$set(this, 'total', res.total);
      }
      this.loadings = false;
    },
    toExam({ data }) {
      this.$set(this, `id`, data.id);
      this.$set(this, `view`, 'order');
    },
    toBack() {
      this.view = 'list';
    },
    toClose() {
      this.searchForm = {};
      this.search();
    },
    // 查询其他信息
    async searchOther() {
      let res;
      // 类型
      res = await this.dictQuery({ code: 'afterSale_type' });
      if (this.$checkRes(res)) this.$set(this, `typeList`, res.data);
      // 售后状态
      res = await this.dictQuery({ code: 'afterSale_status' });
      if (this.$checkRes(res)) this.$set(this, `statusList`, res.data);
    },
  },
  computed: {
    ...mapState(['user']),
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
  watch: {
    test: {
      deep: true,
      immediate: true,
      handler(val) {},
    },
  },
};
</script>

<style lang="less" scoped>
.one {
  margin: 0 0 10px 0;
}
.two {
  margin: 0 0 10px 0;
}
</style>
